Index: /code/trunk/src/modules/questsystem/Quest.cc
===================================================================
--- /code/trunk/src/modules/questsystem/Quest.cc	(revision 7455)
+++ /code/trunk/src/modules/questsystem/Quest.cc	(revision 7456)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file Quest.cc
     @brief Implementation of the Quest class.
 */
@@ -36,9 +36,10 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+
+#include "QuestDescription.h"
+#include "QuestEffect.h"
+#include "QuestHint.h"
+#include "QuestListener.h"
 #include "QuestManager.h"
-#include "QuestDescription.h"
-#include "QuestHint.h"
-#include "QuestEffect.h"
-#include "QuestListener.h"
 
 namespace orxonox
@@ -78,18 +79,19 @@
         XMLPortObject(Quest, QuestEffect, "complete-effects", addCompleteEffect, getCompleteEffect, xmlelement, mode);
 
-        QuestManager::getInstance().registerQuest(this); //!<Registers the Quest with the QuestManager.
-    }
-
-    /**
-    @brief
-        Sets the parentquest of the Quest.
+        QuestManager::getInstance().registerQuest(this); // Registers the Quest with the QuestManager.
+    }
+
+    /**
+    @brief
+        Sets the parent-quest of the Quest.
     @param quest
-        A pointer to the Quest to be set as parentquest.
-    @return
-        Returns true if the parentquest could be set.
+        A pointer to the Quest to be set as parent-quest.
+    @return
+        Returns true if the parent-quest could be set.
     */
     bool Quest::setParentQuest(Quest* quest)
     {
-        if(quest == NULL) //!< We don't want to set NULL-Pointers.
+        //TODO: Replace with assert.
+        if(quest == NULL) // We don't want to set NULL-Pointers.
         {
             COUT(2) << "The parentquest to be added to quest {" << this->getId() << "} was NULL." << std::endl;
@@ -105,13 +107,14 @@
     /**
     @brief
-        Adds a subquest to the Quest.
+        Adds a sub-quest to the Quest.
     @param quest
-        A pointer to the Quest to be set as subquest.
-    @return
-        Returns true if the subquest could be set.
+        A pointer to the Quest to be set as sub-quest.
+    @return
+        Returns true if the sub-quest could be set.
     */
     bool Quest::addSubQuest(Quest* quest)
     {
-        if(quest == NULL) //!< We don't want to set NULL-Pointers.
+        //TODO: Replace with assert.
+        if(quest == NULL) // We don't want to set NULL-Pointers.
         {
             COUT(2) << "The subquest to be added to quest {" << this->getId() << "} was NULL." << std::endl;
@@ -119,6 +122,6 @@
         }
 
-        quest->setParentQuest(this); //!< Sets the currentQuest (this) as parentquest for the added subquest.
-        this->subQuests_.push_back(quest); //!< Adds the Quest to the end of the list of subquests.
+        quest->setParentQuest(this); // Sets the currentQuest (this) as parent-quest for the added sub-quest.
+        this->subQuests_.push_back(quest); // Adds the Quest to the end of the list of sub-quests.
 
         COUT(4) << "Sub Quest {" << quest->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
@@ -137,5 +140,6 @@
     bool Quest::addHint(QuestHint* hint)
     {
-        if(hint == NULL) //!< We don't want to set NULL-Pointers. Seriously!
+        //TODO: Replace with assert.
+        if(hint == NULL) // We don't want to set NULL-Pointers. Seriously!
         {
             COUT(2) << "A NULL-QuestHint was trying to be added." << std::endl;
@@ -143,6 +147,6 @@
         }
 
-        hint->setQuest(this); //!< Sets the current Quest (this) as Quest for the added QuestHint.
-        this->hints_.push_back(hint); //!< Adds the QuestHint to the end of the list of QuestHints.
+        hint->setQuest(this); // Sets the current Quest (this) as Quest for the added QuestHint.
+        this->hints_.push_back(hint); // Adds the QuestHint to the end of the list of QuestHints.
 
         COUT(4) << "QuestHint {" << hint->getId() << "} was added to Quest {" << this->getId() << "}." << std::endl;
@@ -160,5 +164,6 @@
     bool Quest::addFailEffect(QuestEffect* effect)
     {
-        if(effect == NULL) //!< We don't want to set NULL-Pointers.
+        //TODO: Replace with assert.
+        if(effect == NULL) // We don't want to set NULL-Pointers.
         {
             COUT(2) << "A NULL-QuestEffect was trying to be added" << std::endl;
@@ -166,5 +171,5 @@
         }
 
-        this->failEffects_.push_back(effect); //!< Adds the QuestEffect to the end of the list of fail QuestEffects.
+        this->failEffects_.push_back(effect); // Adds the QuestEffect to the end of the list of fail QuestEffects.
 
         COUT(4) << "A FailEffect was added to Quest {" << this->getId() << "}." << std::endl;
@@ -182,5 +187,6 @@
     bool Quest::addCompleteEffect(QuestEffect* effect)
     {
-        if(effect == NULL) //!< We don't want to set NULL-Pointers.
+        //TODO: Replace with assert.
+        if(effect == NULL) // We don't want to set NULL-Pointers.
         {
             COUT(2) << "A NULL-QuestEffect was trying to be added" << std::endl;
@@ -188,5 +194,5 @@
         }
 
-        this->completeEffects_.push_back(effect); //!< Adds the QuestEffect to the end of the list of complete QuestEffects.
+        this->completeEffects_.push_back(effect); // Adds the QuestEffect to the end of the list of complete QuestEffects.
 
         COUT(4) << "A CompleteEffect was added to Quest {" << this->getId() << "}." << std::endl;
@@ -196,9 +202,9 @@
     /**
     @brief
-        Returns the subquest at the given index.
+        Returns the sub-quest at the given index.
     @param index
         The index.
     @return
-        Returns a pointer to the subquest at the given index. NULL if there is no element at the given index.
+        Returns a pointer to the sub-quest at the given index. NULL if there is no element at the given index.
     */
     const Quest* Quest::getSubQuest(unsigned int index) const
@@ -206,15 +212,14 @@
         int i = index;
 
-        //! Iterate through all subquests.
+        // Iterate through all subquests.
         for (std::list<Quest*>::const_iterator subQuest = this->subQuests_.begin(); subQuest != this->subQuests_.end(); ++subQuest)
         {
-            if(i == 0) //!< We're counting down...
-            {
+            if(i == 0) // We're counting down...
                return *subQuest;
-            }
+
             i--;
         }
 
-        return NULL; //!< If the index is greater than the number of elements in the list.
+        return NULL; // If the index is greater than the number of elements in the list.
     }
 
@@ -231,14 +236,13 @@
         int i = index;
 
-        //! Iterate through all QuestHints.
+        // Iterate through all QuestHints.
         for (std::list<QuestHint*>::const_iterator hint = this->hints_.begin(); hint != this->hints_.end(); ++hint)
         {
-            if(i == 0) //!< We're counting down...
-            {
+            if(i == 0) // We're counting down...
                return *hint;
-            }
+
             i--;
         }
-        return NULL; //!< If the index is greater than the number of elements in the list.
+        return NULL; // If the index is greater than the number of elements in the list.
     }
 
@@ -255,14 +259,13 @@
         int i = index;
 
-        //! Iterate through all fail QuestEffects.
+        // Iterate through all fail QuestEffects.
         for (std::list<QuestEffect*>::const_iterator effect = this->failEffects_.begin(); effect != this->failEffects_.end(); ++effect)
         {
-            if(i == 0) //!< We're counting down...
-            {
+            if(i == 0) // We're counting down...
                return *effect;
-            }
+
             i--;
         }
-        return NULL; //!< If the index is greater than the number of elements in the list.
+        return NULL; // If the index is greater than the number of elements in the list.
     }
 
@@ -279,14 +282,13 @@
         int i = index;
 
-        //! Iterate through all complete QuestEffects.
+        // Iterate through all complete QuestEffects.
         for (std::list<QuestEffect*>::const_iterator effect = this->completeEffects_.begin(); effect != this->completeEffects_.end(); ++effect)
         {
-            if(i == 0) //!< We're counting down...
-            {
+            if(i == 0) // We're counting down...
                return *effect;
-            }
+
             i--;
         }
-        return NULL; //!< If the index is greater than the number of elements in the list.
+        return NULL; // If the index is greater than the number of elements in the list.
     }
 
@@ -318,5 +320,4 @@
     bool Quest::isActive(const PlayerInfo* player) const
     {
-
         return this->getStatus(player) == QuestStatus::Active;
     }
@@ -362,5 +363,5 @@
     bool Quest::fail(PlayerInfo* player)
     {
-        QuestListener::advertiseStatusChange(this->listeners_, "fail"); //!< Tells the QuestListeners, that the status has changed to failed.
+        QuestListener::advertiseStatusChange(this->listeners_, "fail"); // Tells the QuestListeners, that the status has changed to failed.
         this->setStatus(player, QuestStatus::Failed);
 
@@ -381,5 +382,5 @@
     bool Quest::complete(PlayerInfo* player)
     {
-        QuestListener::advertiseStatusChange(this->listeners_, "complete"); //!< Tells the QuestListeners, that the status has changed to completed.
+        QuestListener::advertiseStatusChange(this->listeners_, "complete"); // Tells the QuestListeners, that the status has changed to completed.
         this->setStatus(player, QuestStatus::Completed);
 
@@ -400,5 +401,5 @@
     bool Quest::start(PlayerInfo* player)
     {
-        if(!this->isStartable(player)) //!< Checks whether the quest can be started.
+        if(!this->isStartable(player)) // Checks whether the quest can be started.
         {
             COUT(4) << "A non-startable quest was trying to be started." << std::endl;
@@ -408,5 +409,5 @@
         COUT(4) << "Quest {" << this->getId() << "} is started for player: " << player << " ." <<std::endl;
 
-        QuestListener::advertiseStatusChange(this->listeners_, "start"); //!< Tells the QuestListeners, that the status has changed to active.
+        QuestListener::advertiseStatusChange(this->listeners_, "start"); // Tells the QuestListeners, that the status has changed to active.
 
         this->setStatus(player, QuestStatus::Active);
@@ -426,4 +427,5 @@
     bool Quest::addListener(QuestListener* listener)
     {
+        //TODO: Replace with assert?
         if(listener == NULL)
         {
Index: /code/trunk/src/modules/questsystem/Quest.h
===================================================================
--- /code/trunk/src/modules/questsystem/Quest.h	(revision 7455)
+++ /code/trunk/src/modules/questsystem/Quest.h	(revision 7456)
@@ -28,7 +28,8 @@
 
 /**
-    @file
+    @file Quest.h
     @brief Definition of the Quest class.
-        The Quest is the parent class of LocalQuest and GlobalQuest.
+        The Quest class is the parent class of @ref orxonox::LocalQuest "LocalQuest" and @ref orxonox::GlobalQuest "GlobalQuest".
+    @ingroup Questsystem
 */
 
@@ -45,5 +46,5 @@
     namespace QuestStatus
     {
-        //!Different states of a Quest.
+        //! Different states of a @ref orxonox::Quest "Quest".
         enum Value
         {
@@ -57,11 +58,12 @@
     /**
     @brief
-        Represents a Quest in the game.
-        A Quest has a list of subquests and a parentquest (if it is not a rootquest).
+        Represents a Quest in the game. A Quest is a task that the player can (or has to) fulfill upon which he will (possibly) receive some kind of reward.
+
+        A Quest can have a list of sub-quests and has a parent-quest (if it is not a root-quest).
         Each Quest exists only once but it has a different status (inactive, active, failed or completed) for each player.
-        A Quest has several hints (QuestHint) that can be unlocked through QuestEffects and then display aid in solving the Quest.
-        A Quest has a list of QuestEffects that are invoked when the quest is failed and also a list of QuestEffects that are invoked, when the Quest is completed.
+        A Quest can have several hints (QuestHint) that can be unlocked through @ref orxonox::QuestEffect "QuestEffects" and then display aid in solving the Quest.
+        A Quest can have a list of @ref orxonox::QuestEffect "QuestEffects" that are invoked when the quest is failed and also a list of @ref orxonox::QuestEffect "QuestEffects" that are invoked, when the Quest is completed.
 
-        Quest itself should not be instantiated, if you want to create a quest either go for LocalQuest or GlobalQuest, whichever suits you needs better.
+        Quest itself should not be instantiated, if you want to create a quest either use LocalQuest or GlobalQuest, whichever suits you needs better.
     @author
         Damian 'Mozork' Frick
@@ -77,6 +79,6 @@
 
             /**
-            @brief Returns the parentquest of the Quest.
-            @return Returns a pointer to the parentquest of the Quest.
+            @brief Returns the parent-quest of the Quest.
+            @return Returns a pointer to the parent-quest of the Quest.
             */
             inline Quest* getParentQuest(void) const
@@ -84,6 +86,6 @@
 
             /**
-            @brief Returns the list of subquests.
-            @return Returns a reference to the list of subquests of the quest.
+            @brief Returns the list of sub-quests.
+            @return Returns a reference to the list of sub-quests of the quest.
             */
             inline const std::list<Quest*> & getSubQuestList(void) const
@@ -113,5 +115,5 @@
             virtual bool isCompletable(const PlayerInfo* player) const = 0; //!< Checks whether the Quest can be completed.
 
-            const Quest* getSubQuest(unsigned int index) const; //!<Returns the subquest at the given index.
+            const Quest* getSubQuest(unsigned int index) const; //!<Returns the sub-quest at the given index.
             const QuestHint* getHint(unsigned int index) const; //!< Returns the QuestHint at the given index.
             const QuestEffect* getFailEffect(unsigned int index) const; //!< Returns the fail QuestEffect at the given index.
@@ -136,6 +138,6 @@
 
         private:
-            Quest* parentQuest_; //!< Pointer to the parentquest.
-            std::list<Quest*> subQuests_; //!< List of all the subquests.
+            Quest* parentQuest_; //!< Pointer to the parent-quest.
+            std::list<Quest*> subQuests_; //!< List of all the sub-quests.
 
             std::list<QuestHint*> hints_; //!< A list of all the QuestHints tied to this Quest.
@@ -146,6 +148,6 @@
             std::list<QuestListener*> listeners_; //!< A list of QuestListeners, that listen to what exactly happens with this Quest.
 
-            bool setParentQuest(Quest* quest); //!< Sets the parentquest of the Quest.
-            bool addSubQuest(Quest* quest); //!< Adds a subquest to the Quest.
+            bool setParentQuest(Quest* quest); //!< Sets the parent-quest of the Quest.
+            bool addSubQuest(Quest* quest); //!< Adds a sub-quest to the Quest.
             bool addHint(QuestHint* hint); //!< Add a QuestHint to the list of QuestHints.
             bool addFailEffect(QuestEffect* effect); //!< Adds an QuestEffect to the list of fail QuestEffects.
Index: /code/trunk/src/modules/questsystem/QuestDescription.cc
===================================================================
--- /code/trunk/src/modules/questsystem/QuestDescription.cc	(revision 7455)
+++ /code/trunk/src/modules/questsystem/QuestDescription.cc	(revision 7456)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestDescription.cc
     @brief Implementation of the QuestDescription class.
 */
@@ -37,4 +37,5 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+
 #include "QuestNotification.h"
 
@@ -93,21 +94,13 @@
         std::string message;
         if(item == "hint")
-        {
             message = "You received a hint: '" + this->title_ + '\'';
-        }
         else if(item == "quest")
         {
             if(status == "start")
-            {
                 message = "You received a new quest: '" + this->title_ + '\'';
-            }
             else if(status == "fail")
-            {
                 message = "You failed the quest: '" + this->title_ + '\'';
-            }
             else if(status == "complete")
-            {
                 message = "You successfully completed the quest: '" + this->title_ + '\'';
-            }
             else
             {
Index: /code/trunk/src/modules/questsystem/QuestDescription.h
===================================================================
--- /code/trunk/src/modules/questsystem/QuestDescription.h	(revision 7455)
+++ /code/trunk/src/modules/questsystem/QuestDescription.h	(revision 7456)
@@ -28,6 +28,7 @@
 
 /**
-    @file
+    @file QuestDescription.h
     @brief Definition of the QuestDescription class.
+    @ingroup Questsystem
 */
 
@@ -45,9 +46,8 @@
     /**
     @brief
-        This class is a description of a QuestItem.
-        It holds a title and a description.
+        This class is a description of a QuestItem (@ref orxonox::Quest "Quest" and @ref orxonox::QuestHint "QuestHint").
+        It holds a title and a description. For quests also messages that are sent, when failing or completing the quest can be added.
 
         Creating a QuestDescription through XML goes as follows:
-
         @code
         <QuestDescription title="Title" description="Description Text" failMessage="You fail." completeMessage="You win!" />
Index: /code/trunk/src/modules/questsystem/QuestEffect.cc
===================================================================
--- /code/trunk/src/modules/questsystem/QuestEffect.cc	(revision 7455)
+++ /code/trunk/src/modules/questsystem/QuestEffect.cc	(revision 7456)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestEffect.cc
     @brief Implementation of the QuestEffect class.
 */
@@ -64,5 +64,5 @@
         A list of all the QuestEffects to be invoked.
     @return
-        Returns false if there was an error, view console of log for further detail.
+        Returns false if there was an error, view console or log for further details.
     */
     /*static*/ bool QuestEffect::invokeEffects(PlayerInfo* player, std::list<QuestEffect*> & effects)
@@ -73,7 +73,6 @@
 
         for (std::list<QuestEffect*>::iterator effect = effects.begin(); effect != effects.end(); effect++)
-        {
             check = check && (*effect)->invoke(player);
-        }
+
         return check;
     }
Index: /code/trunk/src/modules/questsystem/QuestEffect.h
===================================================================
--- /code/trunk/src/modules/questsystem/QuestEffect.h	(revision 7455)
+++ /code/trunk/src/modules/questsystem/QuestEffect.h	(revision 7456)
@@ -28,6 +28,7 @@
 
 /**
-    @file
+    @file QuestEffect.h
     @brief Definition of the QuestEffect class.
+    @ingroup Questsystem
 */
 
@@ -44,6 +45,6 @@
     /**
     @brief
-        Handles QuestEffects for Quests.
-        QuestEffects are the only way for Quests to have any sideeffects in the game world. They are also the only way for a player to gain, complete or fail Quests.
+        Handles QuestEffects for @ref orxonox::Quest "Quests".
+        QuestEffects are one of the ways for @ref orxonox::Quest "Quests" to have any side effects on the game world and for the game world to influence the @ref orxonox::Quest "Quests".
     @author
         Damian 'Mozork' Frick
@@ -58,5 +59,4 @@
             static bool invokeEffects(PlayerInfo* player, std::list<QuestEffect*> & effects); //!< Invokes all QuestEffects in the list.
 
-
     };
 
Index: /code/trunk/src/modules/questsystem/QuestEffectBeacon.cc
===================================================================
--- /code/trunk/src/modules/questsystem/QuestEffectBeacon.cc	(revision 7455)
+++ /code/trunk/src/modules/questsystem/QuestEffectBeacon.cc	(revision 7456)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestEffectBeacon.cc
     @brief Implementation of the QuestEffectBeacon class.
 */
@@ -37,6 +37,8 @@
 #include "core/XMLPort.h"
 #include "core/EventIncludes.h"
+
+#include "interfaces/PlayerTrigger.h"
 #include "worldentities/pawns/Pawn.h"
-#include "interfaces/PlayerTrigger.h"
+
 #include "objects/triggers/MultiTriggerContainer.h"
 #include "QuestEffect.h"
@@ -50,4 +52,5 @@
         Constructor. Registers the object and initializes defaults.
     */
+    //TODO: Make just BaseObject?
     QuestEffectBeacon::QuestEffectBeacon(BaseObject* creator) : StaticEntity(creator)
     {
@@ -99,4 +102,5 @@
         Returns true if successfully executed, false if not.
     */
+    //TODO: Eliminate MultiTriggerContainer stuff, since they are now PlayerTriggers as well.
     bool QuestEffectBeacon::execute(bool bTriggered, BaseObject* trigger)
     {
@@ -105,5 +109,5 @@
             return false;
         }
-        if(!(this->isActive())) //!< If the QuestEffectBeacon is inactive it cannot be executed.
+        if(!(this->isActive())) // If the QuestEffectBeacon is inactive it cannot be executed.
         {
             COUT(4) << "The QuestEffectBeacon is inactive." << std::endl;
@@ -115,5 +119,5 @@
         Pawn* pawn = NULL;
 
-        //! If the trigger is neither a Playertrigger nor a MultiTrigger (i.e. a MultitriggerContainer) we can do anything with it.
+        // If the trigger is neither a Playertrigger nor a MultiTrigger (i.e. a MultitriggerContainer) we can do anything with it.
         if(pTrigger == NULL && mTrigger == NULL)
             return false;
@@ -122,5 +126,5 @@
         if(pTrigger != NULL)
         {
-            if(!pTrigger->isForPlayer())  //!< The PlayerTrigger is not exclusively for Pawns which means we cannot extract one.
+            if(!pTrigger->isForPlayer())  // The PlayerTrigger is not exclusively for Pawns which means we cannot extract one.
                 return false;
             else
@@ -140,5 +144,5 @@
         }
 
-        //! Extract the PlayerInfo from the Pawn.
+        // Extract the PlayerInfo from the Pawn.
         PlayerInfo* player = pawn->getPlayer();
 
@@ -151,8 +155,8 @@
         COUT(4) << "QuestEffectBeacon executed on player: " << player << " ." << std::endl;
 
-        bool check = QuestEffect::invokeEffects(player, this->effects_); //!< Invoke the QuestEffects on the PlayerInfo.
+        bool check = QuestEffect::invokeEffects(player, this->effects_); // Invoke the QuestEffects on the PlayerInfo.
         if(check)
         {
-            this->decrementTimes(); //!< Decrement the number of times the beacon can be used.
+            this->decrementTimes(); // Decrement the number of times the beacon can be used.
             return true;
         }
@@ -171,13 +175,11 @@
     bool QuestEffectBeacon::setActive(bool activate)
     {
-        if(this->getTimes() == 0 && activate) //!< A QuestEffectBeacon that can be executed only 0 times is always inactive.
-        {
-            return false;
-        }
+        if(this->getTimes() == 0 && activate) // A QuestEffectBeacon that can be executed only 0 times is always inactive.
+            return false;
 
         if(activate)
         {
-        this->status_ = QuestEffectBeaconStatus::Active;
-        return true;
+            this->status_ = QuestEffectBeaconStatus::Active;
+            return true;
         }
 
@@ -194,18 +196,13 @@
     bool QuestEffectBeacon::decrementTimes(void)
     {
-        if(!(this->isActive())) //!< The QuestEffectBeacon mus be active to decrement the number of times it can be executed.
-        {
-            return false;
-        }
-        if(this->getTimes() == INFINITE_TIME) //!< If times is infinity the QuestEffectBeacon can be executed an infinite number fo times.
-        {
+        if(!(this->isActive())) // The QuestEffectBeacon mus be active to decrement the number of times it can be executed.
+            return false;
+
+        if(this->getTimes() == INFINITE_TIME) // If times is infinity the QuestEffectBeacon can be executed an infinite number fo times.
             return true;
-        }
-
-        this->times_ = this->times_ - 1; //!< Decrement number of times the QuestEffectBeacon can be executed.
-        if(this->getTimes() == 0) //!< Set the QuestEffectBeacon to inactive when the number of times it can be executed is reduced to 0.
-        {
+
+        this->times_ = this->times_ - 1; // Decrement number of times the QuestEffectBeacon can be executed.
+        if(this->getTimes() == 0) // Set the QuestEffectBeacon to inactive when the number of times it can be executed is reduced to 0.
             this->status_ = QuestEffectBeaconStatus::Inactive;
-        }
 
         return true;
@@ -225,7 +222,5 @@
     {
         if(n < 0 && n != INFINITE_TIME)
-        {
-            return false;
-        }
+            return false;
 
         this->times_ = n;
@@ -243,5 +238,6 @@
     bool QuestEffectBeacon::addEffect(QuestEffect* effect)
     {
-        if(effect == NULL) //!< NULL-pointers are not well liked here...
+        //TODO: Replace with assert.
+        if(effect == NULL) // NULL-pointers are not well liked here...
         {
             COUT(2) << "A NULL-QuestEffect was trying to be added" << std::endl;
@@ -269,7 +265,6 @@
         {
             if(i == 0)
-            {
                return *effect;
-            }
+
             i--;
         }
Index: /code/trunk/src/modules/questsystem/QuestEffectBeacon.h
===================================================================
--- /code/trunk/src/modules/questsystem/QuestEffectBeacon.h	(revision 7455)
+++ /code/trunk/src/modules/questsystem/QuestEffectBeacon.h	(revision 7456)
@@ -28,6 +28,7 @@
 
 /**
-    @file
+    @file QuestEffectBeacon.h
     @brief Definition of the QuestEffectBeacon class.
+    @ingroup Questsystem
 */
 
@@ -44,5 +45,5 @@
     namespace QuestEffectBeaconStatus
     {
-        //! The status of the beacon, can be either active or inactive.
+        //! The status of the @ref orxonox::QuestEffectBeacon "QuestEffectBeacon", can be either active or inactive.
         enum Value
         {
@@ -54,11 +55,10 @@
     /**
     @brief
-        A QuestEffectBeacon is a physical entity in the game which can (under some condition(s)) invoke a number QuestEffects on players meeting the condition(s).
-        The conditions under which the QuestEffects are invoked on the player are defined by Triggers.
+        A QuestEffectBeacon is a physical entity in the game which can (under some condition(s)) invoke a number of @ref orxonox::QuestEffect "QuestEffects" on players meeting the condition(s).
+        The conditions under which the @ref orxonox::QuestEffect "QuestEffects" are invoked on the player are defined by @ref orxonox::Trigger "Triggers" (or really any kind of entity firing events, e.g. @ref oroxnox::EventListener "EventListeners"). The trigger the event originates from, however has to be a @ref orxonox::PlayerTrigger PlayerTrigger.
         A QuestEffectBeacon can be executed a defined number of times.
-        A QuestEffectBeacon can be inactive or active.
+        A QuestEffectBeacon can be inactive or active. While inactive it can't be executed.
 
         Creating a QuestEffectBeacon through XML goes as follows:
-
         @code
         <QuestEffectBeacon times=n> //Where 'n' is eighter a number >= 0, which means the QuestEffectBeacon can be executed n times. Or n = -1, which means the QuestEffectBeacon can be executed an infinite number of times.
Index: /code/trunk/src/modules/questsystem/QuestHint.cc
===================================================================
--- /code/trunk/src/modules/questsystem/QuestHint.cc	(revision 7455)
+++ /code/trunk/src/modules/questsystem/QuestHint.cc	(revision 7456)
@@ -28,5 +28,5 @@
 
 /**
-    @file
+    @file QuestHint.cc
     @brief Implementation of the QuestHint class.
 */
@@ -36,7 +36,8 @@
 #include "core/CoreIncludes.h"
 #include "core/XMLPort.h"
+
+#include "Quest.h"
+#include "QuestDescription.h"
 #include "QuestManager.h"
-#include "QuestDescription.h"
-#include "Quest.h"
 
 namespace orxonox
@@ -71,5 +72,5 @@
         SUPER(QuestHint, XMLPort, xmlelement, mode);
 
-        QuestManager::getInstance().registerHint(this); //!< Registers the QuestHint with the QuestManager.
+        QuestManager::getInstance().registerHint(this); // Registers the QuestHint with the QuestManager.
 
         COUT(4) << "New QuestHint {" << this->getId() << "} created." << std::endl;
@@ -89,5 +90,6 @@
     bool QuestHint::isActive(const PlayerInfo* player) const
     {
-        if(player == NULL) //!< NULL-Pointers are ugly!
+        //TODO: Replace with asser.
+        if(player == NULL) // NULL-Pointers are ugly!
         {
             ThrowException(Argument, "The input PlayerInfo* is NULL.");
@@ -95,10 +97,8 @@
         }
 
-        //! Find the player.
+        // Find the player.
         std::map<const PlayerInfo*, QuestHintStatus::Value>::const_iterator it = this->playerStatus_.find(player);
-        if (it != this->playerStatus_.end()) //!< If the player is in the map.
-        {
+        if (it != this->playerStatus_.end()) // If the player is in the map.
             return it->second;
-        }
 
         return QuestStatus::Inactive;
@@ -115,7 +115,7 @@
     bool QuestHint::setActive(PlayerInfo* player)
     {
-        if(this->quest_->isActive(player)) //!< For a hint to get activated the quest must be active.
+        if(this->quest_->isActive(player)) // For a hint to get activated the quest must be active.
         {
-            if(!(this->isActive(player)))  //!< If the hint is already active, activation is pointless.
+            if(!(this->isActive(player)))  // If the hint is already active, activation is pointless.
             {
                 this->playerStatus_[player] = QuestHintStatus::Active;
@@ -145,5 +145,6 @@
     bool QuestHint::setQuest(Quest* quest)
     {
-        if(quest == NULL) //!< NULL-Pointer. Again..?
+        //TODO: Replace with assert.
+        if(quest == NULL) // NULL-Pointer. Again..?
         {
             COUT(2) << "The input Quest* is NULL." << std::endl;
Index: /code/trunk/src/modules/questsystem/QuestHint.h
===================================================================
--- /code/trunk/src/modules/questsystem/QuestHint.h	(revision 7455)
+++ /code/trunk/src/modules/questsystem/QuestHint.h	(revision 7456)
@@ -28,6 +28,7 @@
 
 /**
-    @file
+    @file QuestHint.h
     @brief Definition of the QuestHint class.
+    @ingroup Questsystem
 */
 
@@ -42,7 +43,8 @@
 namespace orxonox // tolua_export
 { // tolua_export
+
     namespace QuestHintStatus
     {
-        //! The state of the hint.
+        //! The state of the @ref orxonox::QuestHint "QuestHint".
         enum Value
         {
@@ -54,10 +56,9 @@
     /**
     @brief
-        Represents a hint in the game towards completing a Quest.
-        Consists of title and description (which is stored in a QuestDescription object) in textual form and must belong to a quest.
+        Represents a hint in the game that gives aid towards completing a @ref orxonox::Quest "Quest".
+        Consists of title and description (which is stored in a @ref orxonox::QuestDescription "QuestDescription" object) in textual form and must belong to a quest.
         A QuestHint has a defined status (inactive or active, where inactive is default) for each player, which means each a QuestHint exists only once for all players, it doesn't belong to a player, it just has different states for each of them.
 
         Creating a QuestHint through XML goes as follows:
-
         @code
         <QuestHint id="hintId">
